/*
common - common code for ct programs
*/
static const char rcsid[] = "$Id: common.c,v 1.8 2008/03/07 18:55:50 carl Exp $";

#include 	<parse.h>
#include 	"ct.h"

/*
	ct_print_algo - print type of projection
*/
void ct_print_algo(int algo)
{
	if(algo == CT_PAR){
		parse_wtext("projections: parallel");
	}else if(algo == CT_SPACE){
		parse_wtext("projections: equispace fan-beam");
	}else if(algo == CT_ANGLE){
		parse_wtext("projections: equiangle fan-beam");
	}else{
		parse_er("ct_print_algo: illegal algorithm");
	}
}

/*
	ct_print_mode - print type of projection weighting
*/
void ct_print_mode(MODE imode)
{
	if(imode == HI){
		parse_wtext("mode: 720 interpolative (HI)");
	}else if(imode == OS){
		parse_wtext("mode: overscan (OS)");
	}else if(imode == HE){
		parse_wtext("mode: extrapolative 360 (HE)");
	}else if(imode == HH){
		parse_wtext("mode: helical halfscan (HH)");
	}else if(imode == HS){
		parse_wtext("mode: segment (HS)");
	}else if(imode == US){
		parse_wtext("mode: underscan (US)");
	}else if(imode == HH2){
		parse_wtext("mode: helical halfscan, embodiment 2 (HH2)");
	}else if(imode == FS){
		parse_wtext("mode: pass through (FS)");
	}else if(imode == HSE){
		parse_wtext("mode: segment with extra data (HSE)");
	}else if(imode == HA){
		parse_wtext("mode: asymmetric fan (HA)");
	}else if(imode == HJ){
		parse_wtext("mode: jiang hsieh (HJ)");
	}else{
		parse_er("ct_print_mode: illegal mode");
	}
}

/*
	ct_read_header - read ct header from da-file
*/
void ct_read_header(FILE *iu,HU *hu)
{
	parse_rblock(iu,0,(char *)hu,1);
        parse_from_can_shortv(hu->heads,CT_INT);
        parse_from_can_floatv(hu->headf+CT_FLOAT,128-CT_FLOAT);
}

/*
	ct_write_header - write ct header to da-file
*/
void ct_write_header(FILE *ou,HU *hu)
{
        hu->heads[CT_DA_TYPE] = 0;	/* set in case user forgot */

        parse_to_can_shortv(hu->heads,CT_INT);
        parse_to_can_floatv(hu->headf+CT_FLOAT,128-CT_FLOAT);

        parse_wblock(ou,0,(char *)hu,1);

        parse_from_can_shortv(hu->heads,CT_INT);
        parse_from_can_floatv(hu->headf+CT_FLOAT,128-CT_FLOAT);
}
